// third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom.h is auto generated by mojom_bindings_generator.py, do not edit

// Copyright 2013 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

#ifndef THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_H_
#define THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_H_

#include <stdint.h>

#include <limits>
#include <type_traits>
#include <utility>

#include "third_party/abseil-cpp/absl/types/optional.h"
#include "mojo/public/cpp/bindings/clone_traits.h"
#include "mojo/public/cpp/bindings/equals_traits.h"
#include "mojo/public/cpp/bindings/lib/serialization.h"
#include "mojo/public/cpp/bindings/struct_ptr.h"
#include "mojo/public/cpp/bindings/struct_traits.h"
#include "mojo/public/cpp/bindings/union_traits.h"

#include "third_party/perfetto/include/perfetto/tracing/traced_value_forward.h"

#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-shared.h"
#include "third_party/blink/public/mojom/direct_sockets/direct_sockets.mojom-forward.h"
#include "mojo/public/mojom/base/read_only_buffer.mojom.h"
#include "services/network/public/mojom/ip_endpoint.mojom.h"
#include "services/network/public/mojom/mutable_network_traffic_annotation_tag.mojom-forward.h"
#include "services/network/public/mojom/tcp_socket.mojom.h"
#include "services/network/public/mojom/udp_socket.mojom-forward.h"
#include <string>
#include <vector>

#include "mojo/public/cpp/bindings/lib/control_message_handler.h"
#include "mojo/public/cpp/bindings/raw_ptr_impl_ref_traits.h"


#include "third_party/blink/public/common/common_export.h"




namespace blink {
namespace mojom {

class DirectSocketsServiceProxy;

template <typename ImplRefTraits>
class DirectSocketsServiceStub;

class DirectSocketsServiceRequestValidator;
class DirectSocketsServiceResponseValidator;


class BLINK_COMMON_EXPORT DirectSocketsService
    : public DirectSocketsServiceInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DirectSocketsServiceInterfaceBase;
  using Proxy_ = DirectSocketsServiceProxy;

  template <typename ImplRefTraits>
  using Stub_ = DirectSocketsServiceStub<ImplRefTraits>;

  using RequestValidator_ = DirectSocketsServiceRequestValidator;
  using ResponseValidator_ = DirectSocketsServiceResponseValidator;
  enum MethodMinVersions : uint32_t {
    kOpenTcpSocketMinVersion = 0,
    kOpenUdpSocketMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct OpenTcpSocket_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct OpenUdpSocket_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~DirectSocketsService() = default;


  using OpenTcpSocketCallback = base::OnceCallback<void(int32_t, const absl::optional<::net::IPEndPoint>&, const absl::optional<::net::IPEndPoint>&, ::mojo::ScopedDataPipeConsumerHandle, ::mojo::ScopedDataPipeProducerHandle)>;
  
  virtual void OpenTcpSocket(DirectSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::TCPConnectedSocket> receiver, ::mojo::PendingRemote<::network::mojom::SocketObserver> observer, OpenTcpSocketCallback callback) = 0;


  using OpenUdpSocketCallback = base::OnceCallback<void(int32_t, const absl::optional<::net::IPEndPoint>&, const absl::optional<::net::IPEndPoint>&)>;
  
  virtual void OpenUdpSocket(DirectSocketOptionsPtr options, ::mojo::PendingReceiver<DirectUDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::UDPSocketListener> listener, OpenUdpSocketCallback callback) = 0;
};

class DirectUDPSocketProxy;

template <typename ImplRefTraits>
class DirectUDPSocketStub;

class DirectUDPSocketRequestValidator;
class DirectUDPSocketResponseValidator;


class BLINK_COMMON_EXPORT DirectUDPSocket
    : public DirectUDPSocketInterfaceBase {
 public:
  using IPCStableHashFunction = uint32_t(*)();

  static const char Name_[];
  static IPCStableHashFunction MessageToMethodInfo_(mojo::Message& message);
  static const char* MessageToMethodName_(mojo::Message& message);
  static constexpr uint32_t Version_ = 0;
  static constexpr bool PassesAssociatedKinds_ = false;
  static constexpr bool HasUninterruptableMethods_ = false;

  using Base_ = DirectUDPSocketInterfaceBase;
  using Proxy_ = DirectUDPSocketProxy;

  template <typename ImplRefTraits>
  using Stub_ = DirectUDPSocketStub<ImplRefTraits>;

  using RequestValidator_ = DirectUDPSocketRequestValidator;
  using ResponseValidator_ = DirectUDPSocketResponseValidator;
  enum MethodMinVersions : uint32_t {
    kReceiveMoreMinVersion = 0,
    kSendMinVersion = 0,
    kCloseMinVersion = 0,
  };

// crbug.com/1340245 - this causes binary size bloat on Fuchsia, and we're OK
// with not having this data in traces there.
#if !BUILDFLAG(IS_FUCHSIA)
  struct ReceiveMore_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Send_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
  struct Close_Sym {
    NOINLINE static uint32_t IPCStableHash();
  };
#endif // !BUILDFLAG(IS_FUCHSIA)
  virtual ~DirectUDPSocket() = default;

  
  virtual void ReceiveMore(uint32_t num_additional_datagrams) = 0;


  using SendCallback = base::OnceCallback<void(int32_t)>;
  
  virtual void Send(::base::span<const ::uint8_t> data, SendCallback callback) = 0;

  
  virtual void Close() = 0;
};



class BLINK_COMMON_EXPORT DirectSocketsServiceProxy
    : public DirectSocketsService {
 public:
  using InterfaceType = DirectSocketsService;

  explicit DirectSocketsServiceProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void OpenTcpSocket(DirectSocketOptionsPtr options, ::mojo::PendingReceiver<::network::mojom::TCPConnectedSocket> receiver, ::mojo::PendingRemote<::network::mojom::SocketObserver> observer, OpenTcpSocketCallback callback) final;
  
  void OpenUdpSocket(DirectSocketOptionsPtr options, ::mojo::PendingReceiver<DirectUDPSocket> receiver, ::mojo::PendingRemote<::network::mojom::UDPSocketListener> listener, OpenUdpSocketCallback callback) final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};



class BLINK_COMMON_EXPORT DirectUDPSocketProxy
    : public DirectUDPSocket {
 public:
  using InterfaceType = DirectUDPSocket;

  explicit DirectUDPSocketProxy(mojo::MessageReceiverWithResponder* receiver);
  
  void ReceiveMore(uint32_t num_additional_datagrams) final;
  
  void Send(::base::span<const ::uint8_t> data, SendCallback callback) final;
  
  void Close() final;

 private:
  mojo::MessageReceiverWithResponder* receiver_;
};
class BLINK_COMMON_EXPORT DirectSocketsServiceStubDispatch {
 public:
  static bool Accept(DirectSocketsService* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DirectSocketsService* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DirectSocketsService>>
class DirectSocketsServiceStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DirectSocketsServiceStub() = default;
  ~DirectSocketsServiceStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DirectSocketsServiceStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DirectSocketsServiceStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT DirectUDPSocketStubDispatch {
 public:
  static bool Accept(DirectUDPSocket* impl, mojo::Message* message);
  static bool AcceptWithResponder(
      DirectUDPSocket* impl,
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder);
};

template <typename ImplRefTraits =
              mojo::RawPtrImplRefTraits<DirectUDPSocket>>
class DirectUDPSocketStub
    : public mojo::MessageReceiverWithResponderStatus {
 public:
  using ImplPointerType = typename ImplRefTraits::PointerType;

  DirectUDPSocketStub() = default;
  ~DirectUDPSocketStub() override = default;

  void set_sink(ImplPointerType sink) { sink_ = std::move(sink); }
  ImplPointerType& sink() { return sink_; }

  bool Accept(mojo::Message* message) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DirectUDPSocketStubDispatch::Accept(
        ImplRefTraits::GetRawPointer(&sink_), message);
  }

  bool AcceptWithResponder(
      mojo::Message* message,
      std::unique_ptr<mojo::MessageReceiverWithStatus> responder) override {
    if (ImplRefTraits::IsNull(sink_))
      return false;
    return DirectUDPSocketStubDispatch::AcceptWithResponder(
        ImplRefTraits::GetRawPointer(&sink_), message, std::move(responder));
  }

 private:
  ImplPointerType sink_;
};
class BLINK_COMMON_EXPORT DirectSocketsServiceRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DirectUDPSocketRequestValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DirectSocketsServiceResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};
class BLINK_COMMON_EXPORT DirectUDPSocketResponseValidator : public mojo::MessageReceiver {
 public:
  bool Accept(mojo::Message* message) override;
};








class BLINK_COMMON_EXPORT DirectSocketOptions {
 public:
  template <typename T>
  using EnableIfSame = std::enable_if_t<std::is_same<DirectSocketOptions, T>::value>;
  using DataView = DirectSocketOptionsDataView;
  using Data_ = internal::DirectSocketOptions_Data;

  template <typename... Args>
  static DirectSocketOptionsPtr New(Args&&... args) {
    return DirectSocketOptionsPtr(
        absl::in_place, std::forward<Args>(args)...);
  }

  template <typename U>
  static DirectSocketOptionsPtr From(const U& u) {
    return mojo::TypeConverter<DirectSocketOptionsPtr, U>::Convert(u);
  }

  template <typename U>
  U To() const {
    return mojo::TypeConverter<U, DirectSocketOptions>::Convert(*this);
  }


  DirectSocketOptions();

  DirectSocketOptions(
      const absl::optional<std::string>& local_hostname,
      uint16_t local_port,
      const std::string& remote_hostname,
      uint16_t remote_port,
      int32_t send_buffer_size,
      int32_t receive_buffer_size,
      bool no_delay,
      ::network::mojom::TCPKeepAliveOptionsPtr keep_alive_options);

DirectSocketOptions(const DirectSocketOptions&) = delete;
DirectSocketOptions& operator=(const DirectSocketOptions&) = delete;

  ~DirectSocketOptions();

  // Clone() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Clone() or copy
  // constructor/assignment are available for members.
  template <typename StructPtrType = DirectSocketOptionsPtr>
  DirectSocketOptionsPtr Clone() const;

  // Equals() is a template so it is only instantiated if it is used. Thus, the
  // bindings generator does not need to know whether Equals() or == operator
  // are available for members.
  template <typename T, DirectSocketOptions::EnableIfSame<T>* = nullptr>
  bool Equals(const T& other) const;

  template <typename T, DirectSocketOptions::EnableIfSame<T>* = nullptr>
  bool operator==(const T& rhs) const { return Equals(rhs); }
  template <typename UserType>
  static std::vector<uint8_t> Serialize(UserType* input) {
    return mojo::internal::SerializeImpl<
        DirectSocketOptions::DataView, std::vector<uint8_t>>(input);
  }

  template <typename UserType>
  static mojo::Message SerializeAsMessage(UserType* input) {
    return mojo::internal::SerializeAsMessageImpl<
        DirectSocketOptions::DataView>(input);
  }

  // The returned Message is serialized only if the message is moved
  // cross-process or cross-language. Otherwise if the message is Deserialized
  // as the same UserType |input| will just be moved to |output| in
  // DeserializeFromMessage.
  template <typename UserType>
  static mojo::Message WrapAsMessage(UserType input) {
    return mojo::Message(std::make_unique<
        internal::DirectSocketOptions_UnserializedMessageContext<
            UserType, DirectSocketOptions::DataView>>(0, 0, std::move(input)),
        MOJO_CREATE_MESSAGE_FLAG_NONE);
  }

  template <typename UserType>
  static bool Deserialize(const void* data,
                          size_t data_num_bytes,
                          UserType* output) {
    mojo::Message message;
    return mojo::internal::DeserializeImpl<DirectSocketOptions::DataView>(
        message, data, data_num_bytes, output, Validate);
  }

  template <typename UserType>
  static bool Deserialize(const std::vector<uint8_t>& input,
                          UserType* output) {
    return DirectSocketOptions::Deserialize(
        input.size() == 0 ? nullptr : &input.front(), input.size(), output);
  }

  template <typename UserType>
  static bool DeserializeFromMessage(mojo::Message input,
                                     UserType* output) {
    auto context = input.TakeUnserializedContext<
        internal::DirectSocketOptions_UnserializedMessageContext<
            UserType, DirectSocketOptions::DataView>>();
    if (context) {
      *output = std::move(context->TakeData());
      return true;
    }
    input.SerializeIfNecessary();
    return mojo::internal::DeserializeImpl<DirectSocketOptions::DataView>(
        input, input.payload(), input.payload_num_bytes(), output, Validate);
  }

  
  absl::optional<std::string> local_hostname;
  
  uint16_t local_port;
  
  std::string remote_hostname;
  
  uint16_t remote_port;
  
  int32_t send_buffer_size;
  
  int32_t receive_buffer_size;
  
  bool no_delay;
  
  ::network::mojom::TCPKeepAliveOptionsPtr keep_alive_options;

  // Serialise this struct into a trace.
  void WriteIntoTrace(perfetto::TracedValue traced_context) const;

 private:
  static bool Validate(const void* data,
                       mojo::internal::ValidationContext* validation_context);
};

// The comparison operators are templates, so they are only instantiated if they
// are used. Thus, the bindings generator does not need to know whether
// comparison operators are available for members.
template <typename T, DirectSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<(const T& lhs, const T& rhs);

template <typename T, DirectSocketOptions::EnableIfSame<T>* = nullptr>
bool operator<=(const T& lhs, const T& rhs) {
  return !(rhs < lhs);
}

template <typename T, DirectSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>(const T& lhs, const T& rhs) {
  return rhs < lhs;
}

template <typename T, DirectSocketOptions::EnableIfSame<T>* = nullptr>
bool operator>=(const T& lhs, const T& rhs) {
  return !(lhs < rhs);
}

template <typename StructPtrType>
DirectSocketOptionsPtr DirectSocketOptions::Clone() const {
  return New(
      mojo::Clone(local_hostname),
      mojo::Clone(local_port),
      mojo::Clone(remote_hostname),
      mojo::Clone(remote_port),
      mojo::Clone(send_buffer_size),
      mojo::Clone(receive_buffer_size),
      mojo::Clone(no_delay),
      mojo::Clone(keep_alive_options)
  );
}

template <typename T, DirectSocketOptions::EnableIfSame<T>*>
bool DirectSocketOptions::Equals(const T& other_struct) const {
  if (!mojo::Equals(this->local_hostname, other_struct.local_hostname))
    return false;
  if (!mojo::Equals(this->local_port, other_struct.local_port))
    return false;
  if (!mojo::Equals(this->remote_hostname, other_struct.remote_hostname))
    return false;
  if (!mojo::Equals(this->remote_port, other_struct.remote_port))
    return false;
  if (!mojo::Equals(this->send_buffer_size, other_struct.send_buffer_size))
    return false;
  if (!mojo::Equals(this->receive_buffer_size, other_struct.receive_buffer_size))
    return false;
  if (!mojo::Equals(this->no_delay, other_struct.no_delay))
    return false;
  if (!mojo::Equals(this->keep_alive_options, other_struct.keep_alive_options))
    return false;
  return true;
}

template <typename T, DirectSocketOptions::EnableIfSame<T>*>
bool operator<(const T& lhs, const T& rhs) {
  if (lhs.local_hostname < rhs.local_hostname)
    return true;
  if (rhs.local_hostname < lhs.local_hostname)
    return false;
  if (lhs.local_port < rhs.local_port)
    return true;
  if (rhs.local_port < lhs.local_port)
    return false;
  if (lhs.remote_hostname < rhs.remote_hostname)
    return true;
  if (rhs.remote_hostname < lhs.remote_hostname)
    return false;
  if (lhs.remote_port < rhs.remote_port)
    return true;
  if (rhs.remote_port < lhs.remote_port)
    return false;
  if (lhs.send_buffer_size < rhs.send_buffer_size)
    return true;
  if (rhs.send_buffer_size < lhs.send_buffer_size)
    return false;
  if (lhs.receive_buffer_size < rhs.receive_buffer_size)
    return true;
  if (rhs.receive_buffer_size < lhs.receive_buffer_size)
    return false;
  if (lhs.no_delay < rhs.no_delay)
    return true;
  if (rhs.no_delay < lhs.no_delay)
    return false;
  if (lhs.keep_alive_options < rhs.keep_alive_options)
    return true;
  if (rhs.keep_alive_options < lhs.keep_alive_options)
    return false;
  return false;
}


}  // namespace mojom
}  // namespace blink

namespace mojo {


template <>
struct BLINK_COMMON_EXPORT StructTraits<::blink::mojom::DirectSocketOptions::DataView,
                                         ::blink::mojom::DirectSocketOptionsPtr> {
  static bool IsNull(const ::blink::mojom::DirectSocketOptionsPtr& input) { return !input; }
  static void SetToNull(::blink::mojom::DirectSocketOptionsPtr* output) { output->reset(); }

  static const decltype(::blink::mojom::DirectSocketOptions::local_hostname)& local_hostname(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->local_hostname;
  }

  static decltype(::blink::mojom::DirectSocketOptions::local_port) local_port(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->local_port;
  }

  static const decltype(::blink::mojom::DirectSocketOptions::remote_hostname)& remote_hostname(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->remote_hostname;
  }

  static decltype(::blink::mojom::DirectSocketOptions::remote_port) remote_port(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->remote_port;
  }

  static decltype(::blink::mojom::DirectSocketOptions::send_buffer_size) send_buffer_size(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->send_buffer_size;
  }

  static decltype(::blink::mojom::DirectSocketOptions::receive_buffer_size) receive_buffer_size(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->receive_buffer_size;
  }

  static decltype(::blink::mojom::DirectSocketOptions::no_delay) no_delay(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->no_delay;
  }

  static const decltype(::blink::mojom::DirectSocketOptions::keep_alive_options)& keep_alive_options(
      const ::blink::mojom::DirectSocketOptionsPtr& input) {
    return input->keep_alive_options;
  }

  static bool Read(::blink::mojom::DirectSocketOptions::DataView input, ::blink::mojom::DirectSocketOptionsPtr* output);
};

}  // namespace mojo

#endif  // THIRD_PARTY_BLINK_PUBLIC_MOJOM_DIRECT_SOCKETS_DIRECT_SOCKETS_MOJOM_H_