// Copyright 2014 The Chromium Authors
// Use of this source code is governed by a BSD-style license that can be
// found in the LICENSE file.

// Generated from template:
//   templates/web_runtime_features_base.h.tmpl
// and input files:
//   ../../../../../src/3rdparty/chromium/third_party/blink/renderer/platform/runtime_enabled_features.json5


#ifndef THIRD_PARTY_BLINK_PUBLIC_PLATFORM_WEB_RUNTIME_FEATURES_BASE_H_
#define THIRD_PARTY_BLINK_PUBLIC_PLATFORM_WEB_RUNTIME_FEATURES_BASE_H_

#include "third_party/blink/public/platform/web_common.h"

namespace blink {

class BLINK_PLATFORM_EXPORT WebRuntimeFeaturesBase {
 public:
  static void EnableAccessibilityAriaVirtualContent(bool);
  static bool IsAccessibilityAriaVirtualContentEnabled();
  static void EnableAccessibilityExposeHTMLElement(bool);
  static bool IsAccessibilityExposeHTMLElementEnabled();
  static void EnableAccessibilityExposeIgnoredNodes(bool);
  static bool IsAccessibilityExposeIgnoredNodesEnabled();
  static void EnableAccessibilityPageZoom(bool);
  static bool IsAccessibilityPageZoomEnabled();
  static void EnableAccessibilityUseAXPositionForDocumentMarkers(bool);
  static bool IsAccessibilityUseAXPositionForDocumentMarkersEnabled();
  static void EnableAdTagging(bool);
  static bool IsAdTaggingEnabled();
  static void EnableAndroidDownloadableFontsMatching(bool);
  static bool IsAndroidDownloadableFontsMatchingEnabled();
  static void EnableAnonymousIframe(bool);
  static bool IsAnonymousIframeEnabled();
  static void EnableAOMAriaRelationshipProperties(bool);
  static bool IsAOMAriaRelationshipPropertiesEnabled();
  static void EnableAutoDisableAccessibilityV2(bool);
  static bool IsAutoDisableAccessibilityV2Enabled();
  static void EnableAutomationControlled(bool);
  static bool IsAutomationControlledEnabled();
  static void EnableAutoplayIgnoresWebAudio(bool);
  static bool IsAutoplayIgnoresWebAudioEnabled();
  static void EnableBackForwardCache(bool);
  static bool IsBackForwardCacheEnabled();
  static void EnableBackForwardCacheNotRestoredReasons(bool);
  static bool IsBackForwardCacheNotRestoredReasonsEnabled();
  static void EnableBackgroundFetch(bool);
  static bool IsBackgroundFetchEnabled();
  static void EnableBrowserVerifiedUserActivationKeyboard(bool);
  static bool IsBrowserVerifiedUserActivationKeyboardEnabled();
  static void EnableBrowserVerifiedUserActivationMouse(bool);
  static bool IsBrowserVerifiedUserActivationMouseEnabled();
  static void EnableCanvas2dImageChromium(bool);
  static bool IsCanvas2dImageChromiumEnabled();
  static void EnableClearIdentityInCanMakePaymentEvent(bool);
  static bool IsClearIdentityInCanMakePaymentEventEnabled();
  static void EnableCompositeBGColorAnimation(bool);
  static bool IsCompositeBGColorAnimationEnabled();
  static void EnableCompositedSelectionUpdate(bool);
  static bool IsCompositedSelectionUpdateEnabled();
  static void EnableConsolidatedMovementXY(bool);
  static bool IsConsolidatedMovementXYEnabled();
  static void EnableCooperativeScheduling(bool);
  static bool IsCooperativeSchedulingEnabled();
  static void EnableDatabase(bool);
  static bool IsDatabaseEnabled();
  static void EnableDecodeJpeg420ImagesToYUV(bool);
  static bool IsDecodeJpeg420ImagesToYUVEnabled();
  static void EnableDecodeLossyWebPImagesToYUV(bool);
  static bool IsDecodeLossyWebPImagesToYUVEnabled();
  static void EnableDevicePosture(bool);
  static bool IsDevicePostureEnabled();
  static void EnableDigitalGoods(bool);
  static bool IsDigitalGoodsEnabled();
  static void EnableDirectSockets(bool);
  static bool IsDirectSocketsEnabled();
  static void EnableDisplayCutoutAPI(bool);
  static bool IsDisplayCutoutAPIEnabled();
  static void EnableDocumentPictureInPictureAPI(bool);
  static bool IsDocumentPictureInPictureAPIEnabled();
  static void EnableDocumentPolicy(bool);
  static bool IsDocumentPolicyEnabled();
  static void EnableDocumentPolicyNegotiation(bool);
  static bool IsDocumentPolicyNegotiationEnabled();
  static void EnableEventPath(bool);
  static bool IsEventPathEnabled();
  static void EnableFedCm(bool);
  static bool IsFedCmEnabled();
  static void EnableFedCmIdpSigninStatus(bool);
  static bool IsFedCmIdpSigninStatusEnabled();
  static void EnableFedCmIdpSignout(bool);
  static bool IsFedCmIdpSignoutEnabled();
  static void EnableFedCmIframeSupport(bool);
  static bool IsFedCmIframeSupportEnabled();
  static void EnableFedCmMultipleIdentityProviders(bool);
  static bool IsFedCmMultipleIdentityProvidersEnabled();
  static void EnableFencedFrames(bool);
  static bool IsFencedFramesEnabled();
  static void EnableFileSystem(bool);
  static bool IsFileSystemEnabled();
  static void EnableFileSystemSyncAccessHandleAsyncInterfaceOverride(bool);
  static bool IsFileSystemSyncAccessHandleAsyncInterfaceOverrideEnabled();
  static void EnableForcedColors(bool);
  static bool IsForcedColorsEnabled();
  static void EnableFractionalScrollOffsets(bool);
  static bool IsFractionalScrollOffsetsEnabled();
  static void EnableGetDisplayMedia(bool);
  static bool IsGetDisplayMediaEnabled();
  static void EnableGetDisplayMediaSet(bool);
  static bool IsGetDisplayMediaSetEnabled();
  static void EnableGetDisplayMediaSetAutoSelectAllScreens(bool);
  static bool IsGetDisplayMediaSetAutoSelectAllScreensEnabled();
  static void EnableIdleDetection(bool);
  static bool IsIdleDetectionEnabled();
  static void EnableImplicitRootScroller(bool);
  static bool IsImplicitRootScrollerEnabled();
  static void EnableInstalledApp(bool);
  static bool IsInstalledAppEnabled();
  static void EnableLazyFrameLoading(bool);
  static bool IsLazyFrameLoadingEnabled();
  static void EnableLazyFrameVisibleLoadTimeMetrics(bool);
  static bool IsLazyFrameVisibleLoadTimeMetricsEnabled();
  static void EnableLazyImageLoading(bool);
  static bool IsLazyImageLoadingEnabled();
  static void EnableLazyImageVisibleLoadTimeMetrics(bool);
  static bool IsLazyImageVisibleLoadTimeMetricsEnabled();
  static void EnableLazyInitializeMediaControls(bool);
  static bool IsLazyInitializeMediaControlsEnabled();
  static void EnableMediaCastOverlayButton(bool);
  static bool IsMediaCastOverlayButtonEnabled();
  static void EnableMediaControlsExpandGesture(bool);
  static bool IsMediaControlsExpandGestureEnabled();
  static void EnableMediaControlsOverlayPlayButton(bool);
  static bool IsMediaControlsOverlayPlayButtonEnabled();
  static void EnableMediaEngagementBypassAutoplayPolicies(bool);
  static bool IsMediaEngagementBypassAutoplayPoliciesEnabled();
  static void EnableMediaSession(bool);
  static bool IsMediaSessionEnabled();
  static void EnableMediaSessionWebRTC(bool);
  static bool IsMediaSessionWebRTCEnabled();
  static void EnableMouseSubframeNoImplicitCapture(bool);
  static bool IsMouseSubframeNoImplicitCaptureEnabled();
  static void EnableNetInfoDownlinkMax(bool);
  static bool IsNetInfoDownlinkMaxEnabled();
  static void EnableNeverSlowMode(bool);
  static bool IsNeverSlowModeEnabled();
  static void EnableNotificationContentImage(bool);
  static bool IsNotificationContentImageEnabled();
  static void EnableNotifications(bool);
  static bool IsNotificationsEnabled();
  static void EnablePaymentApp(bool);
  static bool IsPaymentAppEnabled();
  static void EnablePaymentRequest(bool);
  static bool IsPaymentRequestEnabled();
  static void EnablePendingBeaconAPI(bool);
  static bool IsPendingBeaconAPIEnabled();
  static void EnablePercentBasedScrolling(bool);
  static bool IsPercentBasedScrollingEnabled();
  static void EnablePerformanceManagerInstrumentation(bool);
  static bool IsPerformanceManagerInstrumentationEnabled();
  static void EnablePeriodicBackgroundSync(bool);
  static bool IsPeriodicBackgroundSyncEnabled();
  static void EnablePermissions(bool);
  static bool IsPermissionsEnabled();
  static void EnablePictureInPicture(bool);
  static bool IsPictureInPictureEnabled();
  static void EnablePictureInPictureAPI(bool);
  static bool IsPictureInPictureAPIEnabled();
  static void EnablePointerLockOptions(bool);
  static bool IsPointerLockOptionsEnabled();
  static void EnablePortals(bool);
  static bool IsPortalsEnabled();
  static void EnablePreciseMemoryInfo(bool);
  static bool IsPreciseMemoryInfoEnabled();
  static void EnablePrefixedStorageInfo(bool);
  static bool IsPrefixedStorageInfoEnabled();
  static void EnablePrerender2RelatedFeatures(bool);
  static bool IsPrerender2RelatedFeaturesEnabled();
  static void EnablePresentation(bool);
  static bool IsPresentationEnabled();
  static void EnablePushMessaging(bool);
  static bool IsPushMessagingEnabled();
  static void EnablePushMessagingSubscriptionChange(bool);
  static bool IsPushMessagingSubscriptionChangeEnabled();
  static void EnableRemotePlayback(bool);
  static bool IsRemotePlaybackEnabled();
  static void EnableRemoveMobileViewportDoubleTap(bool);
  static bool IsRemoveMobileViewportDoubleTapEnabled();
  static void EnableRestrictGamepadAccess(bool);
  static bool IsRestrictGamepadAccessEnabled();
  static void EnableScriptedSpeechRecognition(bool);
  static bool IsScriptedSpeechRecognitionEnabled();
  static void EnableScriptedSpeechSynthesis(bool);
  static bool IsScriptedSpeechSynthesisEnabled();
  static void EnableSecurePaymentConfirmation(bool);
  static bool IsSecurePaymentConfirmationEnabled();
  static void EnableSecurePaymentConfirmationDebug(bool);
  static bool IsSecurePaymentConfirmationDebugEnabled();
  static void EnableSendBeaconThrowForBlobWithNonSimpleType(bool);
  static bool IsSendBeaconThrowForBlobWithNonSimpleTypeEnabled();
  static void EnableSensorExtraClasses(bool);
  static bool IsSensorExtraClassesEnabled();
  static void EnableSharedArrayBuffer(bool);
  static bool IsSharedArrayBufferEnabled();
  static void EnableSharedArrayBufferOnDesktop(bool);
  static bool IsSharedArrayBufferOnDesktopEnabled();
  static void EnableSharedArrayBufferUnrestrictedAccessAllowed(bool);
  static bool IsSharedArrayBufferUnrestrictedAccessAllowedEnabled();
  static void EnableSharedAutofill(bool);
  static bool IsSharedAutofillEnabled();
  static void EnableSharedStorageAPI(bool);
  static bool IsSharedStorageAPIEnabled();
  static void EnableSharedWorker(bool);
  static bool IsSharedWorkerEnabled();
  static void EnableStorageAccessAPIForOriginExtension(bool);
  static bool IsStorageAccessAPIForOriginExtensionEnabled();
  static void EnableTextFragmentIdentifiers(bool);
  static bool IsTextFragmentIdentifiersEnabled();
  static void EnableTimerThrottlingForBackgroundTabs(bool);
  static bool IsTimerThrottlingForBackgroundTabsEnabled();
  static void EnableTopicsAPI(bool);
  static bool IsTopicsAPIEnabled();
  static void EnableTouchDragAndContextMenu(bool);
  static bool IsTouchDragAndContextMenuEnabled();
  static void EnableTouchEventFeatureDetection(bool);
  static bool IsTouchEventFeatureDetectionEnabled();
  static void EnableTrustTokens(bool);
  static bool IsTrustTokensEnabled();
  static void EnableTrustTokensAlwaysAllowIssuance(bool);
  static bool IsTrustTokensAlwaysAllowIssuanceEnabled();
  static void EnableUserActivationSameOriginVisibility(bool);
  static bool IsUserActivationSameOriginVisibilityEnabled();
  static void EnableV8IdleTasks(bool);
  static bool IsV8IdleTasksEnabled();
  static void EnableVideoPlaybackQuality(bool);
  static bool IsVideoPlaybackQualityEnabled();
  static void EnableVideoWakeLockOptimisationHiddenMuted(bool);
  static bool IsVideoWakeLockOptimisationHiddenMutedEnabled();
  static void EnableWebAuthenticationRemoteDesktopSupport(bool);
  static bool IsWebAuthenticationRemoteDesktopSupportEnabled();
  static void EnableWebBluetooth(bool);
  static bool IsWebBluetoothEnabled();
  static void EnableWebBluetoothGetDevices(bool);
  static bool IsWebBluetoothGetDevicesEnabled();
  static void EnableWebBluetoothWatchAdvertisements(bool);
  static bool IsWebBluetoothWatchAdvertisementsEnabled();
  static void EnableWebGLDeveloperExtensions(bool);
  static bool IsWebGLDeveloperExtensionsEnabled();
  static void EnableWebGLDraftExtensions(bool);
  static bool IsWebGLDraftExtensionsEnabled();
  static void EnableWebGLImageChromium(bool);
  static bool IsWebGLImageChromiumEnabled();
  static void EnableWebGPU(bool);
  static bool IsWebGPUEnabled();
  static void EnableWebGPUDeveloperFeatures(bool);
  static bool IsWebGPUDeveloperFeaturesEnabled();
  static void EnableWebHIDOnServiceWorkers(bool);
  static bool IsWebHIDOnServiceWorkersEnabled();
  static void EnableWebNFC(bool);
  static bool IsWebNFCEnabled();
  static void EnableWebOTP(bool);
  static bool IsWebOTPEnabled();
  static void EnableWebOTPAssertionFeaturePolicy(bool);
  static bool IsWebOTPAssertionFeaturePolicyEnabled();
  static void EnableWebPaymentAPICSP(bool);
  static bool IsWebPaymentAPICSPEnabled();
  static void EnableWebShare(bool);
  static bool IsWebShareEnabled();
  static void EnableWebUSB(bool);
  static bool IsWebUSBEnabled();
  static void EnableWebUSBOnServiceWorkers(bool);
  static bool IsWebUSBOnServiceWorkersEnabled();
  static void EnableWebXR(bool);
  static bool IsWebXREnabled();
  static void EnableWebXRARModule(bool);
  static bool IsWebXRARModuleEnabled();
  static void EnableWebXRCameraAccess(bool);
  static bool IsWebXRCameraAccessEnabled();
  static void EnableWebXRDepth(bool);
  static bool IsWebXRDepthEnabled();
  static void EnableWebXRHandInput(bool);
  static bool IsWebXRHandInputEnabled();
  static void EnableWebXRHitTest(bool);
  static bool IsWebXRHitTestEnabled();
  static void EnableWebXRImageTracking(bool);
  static bool IsWebXRImageTrackingEnabled();
  static void EnableWebXRLightEstimation(bool);
  static bool IsWebXRLightEstimationEnabled();
  static void EnableWebXRPlaneDetection(bool);
  static bool IsWebXRPlaneDetectionEnabled();
  static void EnableWebXRViewportScale(bool);
  static bool IsWebXRViewportScaleEnabled();

  WebRuntimeFeaturesBase() = delete;
};

}  // namespace blink

#endif  // THIRD_PARTY_BLINK_PUBLIC_PLATFORM_WEB_RUNTIME_FEATURES_BASE_H_
